Index: main/plugin-odf/i18n/messages_en.xml
===================================================================
--- main/plugin-odf/i18n/messages_en.xml	(revision 41919)
+++ main/plugin-odf/i18n/messages_en.xml	(working copy)
@@ -658,7 +658,9 @@
 	<message key="PLUGINS_ODF_PROGRAM_DOMAIN_DESC">Ministry field</message>
 	<message key="PLUGINS_ODF_PROGRAM_MENTION">Mention</message>
 	<message key="PLUGINS_ODF_PROGRAM_MENTION_DESC">Mention</message>
-	<message key="PLUGINS_ODF_PROGRAM_SPECIALITY">Speciality</message>
+	<message key="PLUGINS_ODF_PROGRAM_SHARED_WITH">Shared with</message>
+    <message key="PLUGINS_ODF_PROGRAM_SHARED_WITH_DESC">CDMFr code of shared program for co-accredited mentions.&lt;br/&gt;Let this field empty if it's a secondary shared program or just a none shared program.</message>
+    <message key="PLUGINS_ODF_PROGRAM_SPECIALITY">Speciality</message>
 	<message key="PLUGINS_ODF_PROGRAM_SPECIALITY_DESC">Speciality</message>
 	<message key="PLUGINS_ODF_PROGRAM_LEVEL">Target level</message>
 	<message key="PLUGINS_ODF_PROGRAM_LEVEL_DESC">Target evel</message>
Index: main/plugin-odf/i18n/messages_fr.xml
===================================================================
--- main/plugin-odf/i18n/messages_fr.xml	(revision 41919)
+++ main/plugin-odf/i18n/messages_fr.xml	(working copy)
@@ -660,6 +660,8 @@
 	<message key="PLUGINS_ODF_PROGRAM_DOMAIN_DESC">Domaine ministériel</message>
 	<message key="PLUGINS_ODF_PROGRAM_MENTION">Mention</message>
 	<message key="PLUGINS_ODF_PROGRAM_MENTION_DESC">Mention</message>
+	<message key="PLUGINS_ODF_PROGRAM_SHARED_WITH">Partagé avec</message>
+    <message key="PLUGINS_ODF_PROGRAM_SHARED_WITH_DESC">Code CDMFr des parcours de formations partagées secondaires dans le cadre de mentions co-accréditées.&lt;br/&gt;Laisser ce champ vide s'il s'agit d'une formation non partagée ou d'un parcours de formation partagé secondaire</message>
 	<message key="PLUGINS_ODF_PROGRAM_SPECIALITY">Spécialité</message>
 	<message key="PLUGINS_ODF_PROGRAM_SPECIALITY_DESC">Spécialité</message>
 	<message key="PLUGINS_ODF_PROGRAM_LEVEL">Niveau d'étude visé</message>
Index: main/plugin-odf/plugin.xml
===================================================================
--- main/plugin-odf/plugin.xml	(revision 41919)
+++ main/plugin-odf/plugin.xml	(working copy)
@@ -3469,6 +3469,11 @@
                             <custom-enumerator class="org.ametys.odf.enumeration.MentionsEnumerator"/>
                         </enumeration>	
 					</cms:metadata>	
+					<!-- Partagé avec -->
+                    <cms:metadata name="sharedWith" type="string" multiple="true">
+                        <label i18n="true">PLUGINS_ODF_PROGRAM_SHARED_WITH</label>
+                        <description i18n="true">PLUGINS_ODF_PROGRAM_SHARED_WITH_DESC</description>
+                    </cms:metadata> 
 					<!-- Specialite -->
 					<cms:metadata name="speciality" type="string">
 						<label i18n="true">PLUGINS_ODF_PROGRAM_SPECIALITY</label>
@@ -3773,7 +3778,8 @@
 						<cms:metadata-ref name="romeCode" />
 						<cms:metadata-ref name="fapCode" />
 						<cms:metadata-ref name="mention" />
-						<cms:metadata-ref name="speciality" />
+						<cms:metadata-ref name="sharedWith" />
+                        <cms:metadata-ref name="speciality" />
 						<cms:metadata-ref name="educationLevel" />
 						<cms:metadata-ref name="degree" />
 						<cms:metadata-ref name="jointOrgUnit" />
@@ -3875,6 +3881,7 @@
 	               			<cms:label i18n="true">PLUGINS_ODF_PROGRAM_INBRIEF_FIELDSET</cms:label> <!-- En bref -->
 	               			<cms:metadata-ref name="keywords" />
 	               			<cms:metadata-ref name="mention" />
+	               			<cms:metadata-ref name="sharedWith" />
 							<cms:metadata-ref name="speciality" />
 	               			<cms:metadata-ref name="educationKind" />
 	               			<cms:metadata-ref name="duration"/>
Index: main/plugin-odf/src/org/ametys/odf/cdmfr/AmetysCDMfrExtension.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/cdmfr/AmetysCDMfrExtension.java	(revision 41919)
+++ main/plugin-odf/src/org/ametys/odf/cdmfr/AmetysCDMfrExtension.java	(working copy)
@@ -220,6 +220,13 @@
                 XMLUtils.createElement(contentHandler, CDMFRTagsConstants.NAMESPACE_AMETYS_CDM + AbstractProgram.RNCP_LEVEL);
             }
         }
+        
+        // Parcours partagée
+        // <ametys-cdm:sharedWith>FRUAIXXXXXPRYYYYY</ametys-cdm:sharedWith>
+        for (String sharedProgram : program.getStringArray(AbstractProgram.SHARED_WITH))
+        {
+            XMLUtils.createElement(contentHandler, CDMFRTagsConstants.NAMESPACE_AMETYS_CDM + AbstractProgram.SHARED_WITH, sharedProgram);
+        }
     }
     
     private void _sortRepeaterEntries(String[] entryNames)
Index: main/plugin-odf/src/org/ametys/odf/program/AbstractProgram.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/program/AbstractProgram.java	(revision 41919)
+++ main/plugin-odf/src/org/ametys/odf/program/AbstractProgram.java	(working copy)
@@ -225,6 +225,9 @@
     /** Constants for metadata 'keywords' */
     public static final String KEYWORDS = "keywords";
     
+    /** Constants for metadata 'sharedWith' (for shared program in a co-accredited mention only) */
+    public static final String SHARED_WITH = "sharedWith";
+    
     /**
      * References
      */
@@ -1459,6 +1462,15 @@
         getMetadataHolder().setMetadata(KEYWORDS, keywords);
     }
     
+    /**
+     * Get the CDMfr codes of shared (sub)programs
+     * @return the CDMfr codes
+     */
+    public String[] getSharedWith()
+    {
+        return getStringArray(SHARED_WITH);
+    }
+    
     // --------------------------------------------------------------------------------------//
     // CDM-fr
     // --------------------------------------------------------------------------------------//