Index: main/plugin-odf/doc/constants/mention_licence.xml
===================================================================
--- main/plugin-odf/doc/constants/mention_licence.xml	(revision 41989)
+++ main/plugin-odf/doc/constants/mention_licence.xml	(working copy)
@@ -33,15 +33,15 @@
     <item code="XA_16" i18n-key="APPLICATION_ODF_MENTION_LICENCE_16" cdmValue="Philosophie"/>
     <item code="XA_17" i18n-key="APPLICATION_ODF_MENTION_LICENCE_17" cdmValue="Théologie"/>
     <item code="XA_18" i18n-key="APPLICATION_ODF_MENTION_LICENCE_18" cdmValue="Sciences sociales"/>
-    <item code="XA_19" i18n-key="APPLICATION_ODF_MENTION_LICENCE_19" cdmValue="Sciences de l'Homme, Anthropologie, Ethnologie"/>
+    <item code="XA_19" i18n-key="APPLICATION_ODF_MENTION_LICENCE_19" cdmValue="Sciences de l'homme, anthropologie, ethnologie"/>
     <item code="XA_20" i18n-key="APPLICATION_ODF_MENTION_LICENCE_20" cdmValue="Sciences du langage"/>
-    <item code="XA_21" i18n-key="APPLICATION_ODF_MENTION_LICENCE_21" cdmValue="Information-Communication"/>
+    <item code="XA_21" i18n-key="APPLICATION_ODF_MENTION_LICENCE_21" cdmValue="Information-communication"/>
     <item code="XA_22" i18n-key="APPLICATION_ODF_MENTION_LICENCE_22" cdmValue="Arts"/>
     <item code="XA_23" i18n-key="APPLICATION_ODF_MENTION_LICENCE_23" cdmValue="Arts plastiques"/>
     <item code="XA_24" i18n-key="APPLICATION_ODF_MENTION_LICENCE_24" cdmValue="Arts du spectacle"/>
     <item code="XA_25" i18n-key="APPLICATION_ODF_MENTION_LICENCE_25" cdmValue="Musicologie"/>
     <item code="XA_26" i18n-key="APPLICATION_ODF_MENTION_LICENCE_26" cdmValue="Lettres"/>
-    <item code="XA_27" i18n-key="APPLICATION_ODF_MENTION_LICENCE_27" cdmValue="Langues, littératures &amp; civilisations étrangères et régionales"/>
+    <item code="XA_27" i18n-key="APPLICATION_ODF_MENTION_LICENCE_27" cdmValue="Langues, littératures et civilisations étrangères et régionales"/>
     <item code="XA_28" i18n-key="APPLICATION_ODF_MENTION_LICENCE_28" cdmValue="Langues étrangères appliquées"/>
     <item code="XA_29" i18n-key="APPLICATION_ODF_MENTION_LICENCE_29" cdmValue="Lettres, langues"/>
     <item code="XA_30" i18n-key="APPLICATION_ODF_MENTION_LICENCE_30" cdmValue="Informatique"/>
@@ -51,10 +51,10 @@
     <item code="XA_34" i18n-key="APPLICATION_ODF_MENTION_LICENCE_34" cdmValue="Chimie"/>
     <item code="XA_35" i18n-key="APPLICATION_ODF_MENTION_LICENCE_35" cdmValue="Physique, chimie"/>
     <item code="XA_36" i18n-key="APPLICATION_ODF_MENTION_LICENCE_36" cdmValue="Sciences de la vie"/>
-    <item code="XA_37" i18n-key="APPLICATION_ODF_MENTION_LICENCE_37" cdmValue="Sciences de la terre"/>
-    <item code="XA_38" i18n-key="APPLICATION_ODF_MENTION_LICENCE_38" cdmValue="Sciences de la vie et de la terre"/>
+    <item code="XA_37" i18n-key="APPLICATION_ODF_MENTION_LICENCE_37" cdmValue="Sciences de la Terre"/>
+    <item code="XA_38" i18n-key="APPLICATION_ODF_MENTION_LICENCE_38" cdmValue="Sciences de la vie et de la Terre"/>
     <item code="XA_39" i18n-key="APPLICATION_ODF_MENTION_LICENCE_39" cdmValue="Sciences et techniques des activités physiques et sportives"/>
-    <item code="XA_40" i18n-key="APPLICATION_ODF_MENTION_LICENCE_40" cdmValue="Electrotechnique, électronique, automatique"/>
+    <item code="XA_40" i18n-key="APPLICATION_ODF_MENTION_LICENCE_40" cdmValue="Electronique, énergie électrique, automatique"/>
     <item code="XA_41" i18n-key="APPLICATION_ODF_MENTION_LICENCE_41" cdmValue="Mécanique"/>
     <item code="XA_42" i18n-key="APPLICATION_ODF_MENTION_LICENCE_42" cdmValue="Génie civil"/>
     <item code="XA_43" i18n-key="APPLICATION_ODF_MENTION_LICENCE_43" cdmValue="Sciences pour la santé"/>
Index: main/plugin-odf/doc/constants/mention_licencepro.xml
===================================================================
--- main/plugin-odf/doc/constants/mention_licencepro.xml	(revision 41989)
+++ main/plugin-odf/doc/constants/mention_licencepro.xml	(working copy)
@@ -74,7 +74,7 @@
     <item code="DP_57" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_57" cdmValue="Installations frigorifiques et de conditionnement d’air" />
     <item code="DP_58" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_58" cdmValue="Intervention sociale : accompagnement de publics spécifiques" />
     <item code="DP_59" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_59" cdmValue="Intervention sociale : insertion et réinsertion sociale et professionnelle" />
-    <item code="DP_60" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_60" cdmValue="Intervention sociale : médiation par le sport" />
+    <item code="DP_60" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_60" cdmValue="Intervention sociale : développement social et médiation par le sport" />
     <item code="DP_61" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_61" cdmValue="Intervention sociale : accompagnement social" />
     <item code="DP_62" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_62" cdmValue="Logistique et pilotage des flux" />
     <item code="DP_63" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_63" cdmValue="Logistique et systèmes d’information" />
@@ -143,12 +143,12 @@
     <item code="DP_126" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_126" cdmValue="Métiers de l’industrie : métallurgie, mise en forme des matériaux et soudage" />
     <item code="DP_127" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_127" cdmValue="Métiers de l’information : archives, médiation et patrimoine" />
     <item code="DP_128" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_128" cdmValue="Métiers de l’information : métiers du journalisme et de la presse" />
-    <item code="DP_129" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_129" cdmValue="Métiers de l’informatique : administration et sécurité des systèmes" />
+    <item code="DP_174" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_174" cdmValue="Métiers de l’information : veille et gestion des ressources documentaires" />
+    <item code="DP_129" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_129" cdmValue="Métiers de l’informatique : administration et sécurité des systèmes et des réseaux" />
     <item code="DP_130" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_130" cdmValue="Métiers de l’informatique : conduite de projets" />
-    <item code="DP_131" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_131" cdmValue="Métiers de l’informatique : développement d’applications" />
-    <item code="DP_132" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_132" cdmValue="Métiers de l’informatique : développement internet et intranet" />
-    <item code="DP_133" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_133" cdmValue="Métiers de l’informatique : systèmes d’information et gestion des bases de données" />
-    <item code="DP_134" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_134" cdmValue="Métiers de l’informatique : test et qualité des logiciels" />
+    <item code="DP_132" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_132" cdmValue="Métiers de l’informatique : applications web" />
+    <item code="DP_133" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_133" cdmValue="Métiers de l’informatique : systèmes d’information et gestion de données" />
+    <item code="DP_175" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_175" cdmValue="Métiers de l’informatique : conception, développement et test de logiciels" />
     <item code="DP_135" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_135" cdmValue="Métiers de l’instrumentation, de la mesure et du contrôle qualité" />
     <item code="DP_136" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_136" cdmValue="Métiers des administrations et collectivités territoriales" />
     <item code="DP_137" i18n-key="APPLICATION_ODF_MENTION_LICENCEPRO_137" cdmValue="Métiers des arts culinaires et des arts de la table" />
Index: main/plugin-odf/doc/i18n/application.xml
===================================================================
--- main/plugin-odf/doc/i18n/application.xml	(revision 41989)
+++ main/plugin-odf/doc/i18n/application.xml	(working copy)
@@ -1901,7 +1901,7 @@
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_57">Installations frigorifiques et de conditionnement d’air</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_58">Intervention sociale : accompagnement de publics spécifiques</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_59">Intervention sociale : insertion et réinsertion sociale et professionnelle</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_60">Intervention sociale : médiation par le sport</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_60">Intervention sociale : développement social et médiation par le sport</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_61">Intervention sociale : accompagnement social</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_62">Logistique et pilotage des flux</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_63">Logistique et systèmes d’information</message>
@@ -1970,12 +1970,12 @@
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_126">Métiers de l’industrie : métallurgie, mise en forme des matériaux et soudage</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_127">Métiers de l’information : archives, médiation et patrimoine</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_128">Métiers de l’information : métiers du journalisme et de la presse</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_129">Métiers de l’informatique : administration et sécurité des systèmes</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_174">Métiers de l’information : veille et gestion des ressources documentaires</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_129">Métiers de l’informatique : administration et sécurité des systèmes et des réseaux</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_130">Métiers de l’informatique : conduite de projets</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_131">Métiers de l’informatique : développement d’applications</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_132">Métiers de l’informatique : développement internet et intranet</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_133">Métiers de l’informatique : systèmes d’information et gestion des bases de données</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_134">Métiers de l’informatique : test et qualité des logiciels</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_132">Métiers de l’informatique : applications web</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_133">Métiers de l’informatique : systèmes d’information et gestion de données</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_175">Métiers de l’informatique : conception, développement et test de logiciels</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_135">Métiers de l’instrumentation, de la mesure et du contrôle qualité</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_136">Métiers des administrations et collectivités territoriales</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_137">Métiers des arts culinaires et des arts de la table</message>
Index: main/plugin-odf/doc/i18n/application_en.xml
===================================================================
--- main/plugin-odf/doc/i18n/application_en.xml	(revision 41989)
+++ main/plugin-odf/doc/i18n/application_en.xml	(working copy)
@@ -1901,7 +1901,7 @@
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_57">Installations frigorifiques et de conditionnement d’air</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_58">Intervention sociale : accompagnement de publics spécifiques</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_59">Intervention sociale : insertion et réinsertion sociale et professionnelle</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_60">Intervention sociale : médiation par le sport</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_60">Intervention sociale : développement social et médiation par le sport</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_61">Intervention sociale : accompagnement social</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_62">Logistique et pilotage des flux</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_63">Logistique et systèmes d’information</message>
@@ -1970,12 +1970,12 @@
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_126">Métiers de l’industrie : métallurgie, mise en forme des matériaux et soudage</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_127">Métiers de l’information : archives, médiation et patrimoine</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_128">Métiers de l’information : métiers du journalisme et de la presse</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_129">Métiers de l’informatique : administration et sécurité des systèmes</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_174">Métiers de l’information : veille et gestion des ressources documentaires</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_129">Métiers de l’informatique : administration et sécurité des systèmes et des réseaux</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_130">Métiers de l’informatique : conduite de projets</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_131">Métiers de l’informatique : développement d’applications</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_132">Métiers de l’informatique : développement internet et intranet</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_133">Métiers de l’informatique : systèmes d’information et gestion des bases de données</message>
-    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_134">Métiers de l’informatique : test et qualité des logiciels</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_132">Métiers de l’informatique : applications web</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_133">Métiers de l’informatique : systèmes d’information et gestion de données</message>
+    <message key="APPLICATION_ODF_MENTION_LICENCEPRO_175">Métiers de l’informatique : conception, développement et test de logiciels</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_135">Métiers de l’instrumentation, de la mesure et du contrôle qualité</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_136">Métiers des administrations et collectivités territoriales</message>
     <message key="APPLICATION_ODF_MENTION_LICENCEPRO_137">Métiers des arts culinaires et des arts de la table</message>