Index: main/plugin-odf/plugin.xml
===================================================================
--- main/plugin-odf/plugin.xml	(revision 44375)
+++ main/plugin-odf/plugin.xml	(working copy)
@@ -4158,7 +4158,18 @@
 					<cms:metadata name="ects" type="long">
 						<label i18n="true">PLUGINS_ODF_PROGRAM_ECTS</label>
 						<description i18n="true">PLUGINS_ODF_PROGRAM_ECTS_DESC</description>		
-					</cms:metadata>				
+					</cms:metadata>
+					<!-- Nature -->        
+                    <cms:metadata name="educationKind" type="string">
+                        <label i18n="true">PLUGINS_ODF_PROGRAM_NATURE</label>
+                        <description i18n="true">PLUGINS_ODF_PROGRAM_NATURE_DESC</description>  
+                        <widget>sorted-enumeration</widget>
+                        <enumeration>
+                            <custom-enumerator class="org.ametys.odf.enumeration.StaticODFEnumerator">
+                                <constant>PROGRAM_TYPE</constant>
+                            </custom-enumerator>
+                        </enumeration>      
+                    </cms:metadata>			
 					<!-- Effectifs inscrits totaux -->
 					<cms:metadata name="numberOfStudents" type="long">
 						<label i18n="true">PLUGINS_ODF_PROGRAM_TOTAL_STUDENTS</label>
@@ -4415,6 +4426,7 @@
 					    <cms:metadata-ref name="programWebSiteUrl" />
 					    <cms:metadata-ref name="successRate"/>
 						<cms:metadata-ref name="ects"/>
+						<cms:metadata-ref name="educationKind"/>
 						<cms:metadata-ref name="numberOfStudents"/>
 						<cms:metadata-ref name="expenses"/>
 						<cms:metadata-ref name="formofteachingOrg"/>
@@ -4503,7 +4515,8 @@
 	               			<cms:label i18n="true">PLUGINS_ODF_PROGRAM_INBRIEF_FIELDSET</cms:label> <!-- En bref -->
 	               			<cms:metadata-ref name="keywords" />
 							<cms:metadata-ref name="ects"/>
-							<cms:metadata-ref name="numberOfStudents"/>
+							<cms:metadata-ref name="educationKind"/>
+                            <cms:metadata-ref name="numberOfStudents"/>
 							<cms:metadata-ref name="expenses"/>
 							<cms:metadata-ref name="formofteachingOrg"/>
 							<cms:metadata-ref name="distanceLearning" />
@@ -4539,15 +4552,23 @@
 	                	<cms:metadata-ref name="code" />
 					</cms:metadata-set>
 	                
+	                <cms:metadata-set name="parcours" type="view">
+                        <cms:metadata-ref name="title" />
+                        <cms:metadata-ref name="code" />
+                        <cms:metadata-ref name="orgUnit" />
+                        <cms:metadata-ref name="place" />
+                    </cms:metadata-set>
+					
 	                <cms:metadata-set name="details" type="view" internal="true">
 	                	<cms:metadata-ref name="title" />
 	                	<cms:metadata-ref name="code" />
 	                </cms:metadata-set>
-					
+	                
                     <cms:metadata-set name="index" type="view" internal="true"> 
 	                	<cms:metadata-ref name="title" />
 	                	<cms:metadata-ref name="keywords" />
-	                	<cms:metadata-ref name="presentation"/>
+	                	<cms:metadata-ref name="educationKind"/>
+                        <cms:metadata-ref name="presentation"/>
 	                	<cms:metadata-ref name="objectives"/>
 	                	<cms:metadata-ref name="distanceLearning" />
                         <cms:metadata-ref name="formofteachingOrg" />
Index: main/plugin-odf/src/org/ametys/odf/program/generators/ProgramContentGenerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/program/generators/ProgramContentGenerator.java	(revision 44375)
+++ main/plugin-odf/src/org/ametys/odf/program/generators/ProgramContentGenerator.java	(working copy)
@@ -341,7 +341,20 @@
         {
             attrs.addCDATAAttribute("path", parentPath + "/" + subProgram.getName());
         }
+        
         XMLUtils.startElement(contentHandler, "subprogram", attrs);
+        if ("P".equals(subProgram.getString(AbstractProgram.EDUCATION_KIND)))
+        {
+            try
+            {
+                saxContent(subProgram, "parcours", "xml", false);
+            }
+            catch (IOException e)
+            {
+                throw new SAXException(e);
+            }
+        }
+        
         XMLUtils.endElement(contentHandler, "subprogram");
     }
     
@@ -516,6 +529,20 @@
             format = "html";
         }
         
+        saxContent(content, metadataSetName, format, true);
+    }
+    
+    /**
+     * SAX the HTML content of a {@link Content}
+     * @param content the content
+     * @param metadataSetName the metadata set name
+     * @param format the format
+     * @param withContentRoot true to wrap content stream into a content tag
+     * @throws SAXException
+     * @throws IOException
+     */
+    protected void saxContent (Content content, String metadataSetName, String format, boolean withContentRoot) throws SAXException, IOException
+    {
         SitemapSource src = null;      
         try
         {
@@ -523,17 +550,21 @@
             
             src = (SitemapSource) _srcResolver.resolveURI(uri);
             
-            AttributesImpl attrs = new AttributesImpl();
-            attrs.addCDATAAttribute("id", content.getId());
-            attrs.addCDATAAttribute("name", content.getName());
-            attrs.addCDATAAttribute("title", content.getTitle());
-            attrs.addCDATAAttribute("lastModifiedAt", ParameterHelper.valueToString(content.getLastModified()));
-            
-            XMLUtils.startElement(contentHandler, "content", attrs);
-            
+            if (withContentRoot)
+            {
+                AttributesImpl attrs = new AttributesImpl();
+                attrs.addCDATAAttribute("id", content.getId());
+                attrs.addCDATAAttribute("name", content.getName());
+                attrs.addCDATAAttribute("title", content.getTitle());
+                attrs.addCDATAAttribute("lastModifiedAt", ParameterHelper.valueToString(content.getLastModified()));
+                XMLUtils.startElement(contentHandler, "content", attrs);
+            }
             src.toSAX(new IgnoreRootHandler(contentHandler));
             
-            XMLUtils.endElement(contentHandler, "content");
+            if (withContentRoot)
+            {
+                XMLUtils.endElement(contentHandler, "content");
+            }
         }
         catch (UnknownAmetysObjectException e)
         {