Index: main/plugin-odf/src/org/ametys/odf/enumeration/AbstractODFEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/AbstractODFEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/AbstractODFEnumerator.java	(working copy)
@@ -102,15 +102,14 @@
      * Returns the enumeration name
      * @return the enumeration name
      */
-    protected abstract String getEnumerationName ();
+    public abstract String getEnumerationName ();
     
     /**
-     * Returns the enumeration name
-     * @return the enumeration name
+     * Returns true if sub items are used
+     * @return true if sub items are used
      */
     protected boolean useSubitems()
     {
         return false;
     }
-    
 }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeCite97Enumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeCite97Enumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeCite97Enumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeCite97Enumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_CITE97;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeDGESIPEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeDGESIPEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeDGESIPEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeDGESIPEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_DGESIP;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeErasmusEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeErasmusEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeErasmusEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeErasmusEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_ERASMUS;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeFAPEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeFAPEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeFAPEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeFAPEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_FAP;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeRomeEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeRomeEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeRomeEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeRomeEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_ROME;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/CodeSISEEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/CodeSISEEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/CodeSISEEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class CodeSISEEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.CODE_SISE;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/DegreesEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/DegreesEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/DegreesEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class DegreesEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.DEGREE;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/DistanceLearningModalitiesEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/DistanceLearningModalitiesEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/DistanceLearningModalitiesEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class DistanceLearningModalitiesEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.DISTANCE_LEARNING_MODALITIES;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/DomainsEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/DomainsEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/DomainsEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class DomainsEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.DOMAIN;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/EducationTypesEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/EducationTypesEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/EducationTypesEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class EducationTypesEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.PROGRAM_TYPE;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingEnumerator.java	(working copy)
@@ -26,7 +26,7 @@
 {
 
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.TEACHING_ACTIVITY;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingOrgEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingOrgEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/FormOfTeachingOrgEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class FormOfTeachingOrgEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.FORMOFTEACHING_ORG;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/InternshipEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/InternshipEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/InternshipEnumerator.java	(working copy)
@@ -26,7 +26,7 @@
 {
 
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.INTERNSHIP;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/JoinOrgunitEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/JoinOrgunitEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/JoinOrgunitEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class JoinOrgunitEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.JOIN_ORGUNIT;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/LevelsEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/LevelsEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/LevelsEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class LevelsEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.LEVEL;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/PlacesEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/PlacesEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/PlacesEnumerator.java	(working copy)
@@ -26,7 +26,7 @@
 {
     
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.PLACE;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/StaticODFEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/StaticODFEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/StaticODFEnumerator.java	(working copy)
@@ -58,7 +58,7 @@
     }
     
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return _enumerationName;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/TeachingMethodsEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/TeachingMethodsEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/TeachingMethodsEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class TeachingMethodsEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.FORMOFTEACHING_METHOD;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/TeachingTermsEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/TeachingTermsEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/TeachingTermsEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class TeachingTermsEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.TEACHING_TERM;
     }
Index: main/plugin-odf/src/org/ametys/odf/enumeration/TimeSlotsEnumerator.java
===================================================================
--- main/plugin-odf/src/org/ametys/odf/enumeration/TimeSlotsEnumerator.java	(revision 51724)
+++ main/plugin-odf/src/org/ametys/odf/enumeration/TimeSlotsEnumerator.java	(working copy)
@@ -25,7 +25,7 @@
 public class TimeSlotsEnumerator extends AbstractODFEnumerator
 {
     @Override
-    protected String getEnumerationName()
+    public String getEnumerationName()
     {
         return OdfEnumerationConstant.TIME_SLOT;
     }